#include <pic18f4580.h>
#include "initcan.h"


void initcan (void)
{
	unsigned char configwait=1;
	TRISBbits.TRISB2=0;			// Transmissiom TX=Output
	TRISBbits.TRISB3=1;			// Reception RX=Input
	CANCON=0b10000000; 				// Mode Configuration bit

	ECANCON=0b00000000;				// Legacy mode (default)

 //Initialize the speed transmission
	
	BRGCON1=0b11000010;  // PARAMETERS to explain to Dirk
	BRGCON2=0b11110111;
	BRGCON3=0b00000011;


/*********   Initialize the Mask and Filters    **************/
// Mask

RXM0EIDH=0x00;			// Not use
RXM0EIDL=0x00;			// Not use
RXM0SIDH=0x07;			// To accept can id 1,2,3
RXM0SIDL=0xFC;		


RXM1EIDH=0x00;			// Not use
RXM1EIDL=0x00;			// Not use
RXM1SIDH=0x07;		
RXM1SIDL=0xFC;

// Filters  
//RXFCON0=0x03;		// to activate only filters  RXF0 and RXF1
//RXFCON1=0x00;




CANCON=0x00;	// Set in Normal Mode
RXB0CON=0x00;   // Set Rceive Mode for RXB0
RXB1CON=0x00;   // Set Rceive Mode for RXB1

}



unsigned char receive_message(void)
{
	if((PIR3bits.RXB0IF==1)||(PIR3bits.RXB1IF==1))
		return TRUE;
	else
		return FALSE;
}





void transmit_message(void)
{
	CANCON=0x08;   
	TXB0CONbits.TXREQ=0;
	TXB0SIDH=0x00;	// ID Declaration, ID=4 and standard format
    TXB0SIDL=0x80;	// ID Declaration, ID=4 and standard format
	TXB0DLC=0x08;	// Data Length of 8 bytes
	

	//Data of Frame to send
	TXB0D0=0xFF;
	TXB0D1=0xFF;
	TXB0D2=0xFF;
	TXB0D3=0x00;
	TXB0D4=0x00;
    TXB0D5=0xFF;
	TXB0D6=0xFF;
	TXB0D7=0xFF;
	do{
	TXB0CON=0b00001000;		// to send the message
	}while(TXB0CONbits.TXREQ==0);
}

